Imports System.Xml.Serialization
Imports System.IO

Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Make a SerializableDictionary.
        Dim dict As New SerializableDictionary(Of String, Integer)
        dict.Add("one", 1)
        dict.Add("two", 2)
        dict.Add("three", 3)
        dict.Add("four", 4)
        dict.Add("five", 5)

        ' Show the serialization.
        Dim xml_serializer As New XmlSerializer(GetType(SerializableDictionary(Of String, Integer)))
        Dim txt As String
        Using string_writer As New StringWriter()
            xml_serializer.Serialize(string_writer, dict)
            txt = string_writer.ToString
            string_writer.Close()
        End Using

        ' Deserialize.
        Using string_reader As New StringReader(txt)
            dict = DirectCast(xml_serializer.Deserialize(string_reader), SerializableDictionary(Of String, Integer))
        End Using

        txt &= vbCrLf & "***********" & vbCrLf
        For Each key As String In dict.Keys
            txt &= key & ": " & dict.Item(key) & vbCrLf
        Next key

        txtResult.Text = txt
        txtResult.Select(0, 0)
    End Sub
End Class
